<?php

namespace GGM\ProductManagerImplementation\Controller\Index;

use Exception;
use Magento\Framework\App\Action\Action;
use GGM\ProductManagerImplementation\ProductManagerMagento2;
use Magento\Framework\App\Area;
use Magento\Framework\App\Bootstrap;
use Magento\Framework\App\Request\InvalidRequestException;
use Magento\Framework\App\RequestInterface;
use Magento\Framework\Exception\AuthenticationException;

/**
 * Class Index
 */
class Index extends Action
{
    /**
     * {@inheritdoc}
     *
     * @throws AuthenticationException
     */
    public function execute()
    {
        ob_start();
        ini_set('display_errors', 1);
        ini_set('track_errors', 1);
        ini_set('html_errors', 1);

        $encryptionKey = 'qWP0VAntI50zXK9sMre6oD+4caiSG3CM8BNfBiL8oXA=';
        $postData = ProductManagerMagento2\Magento2Router::getJSONFromPOSTFields($encryptionKey);

        $username = (string)$postData[0]->username;
        $password = '';

        $bootstrapMagento2 = 0;
        try {
            if (class_exists(Bootstrap::class)) {
                $bootstrapMagento2 = Bootstrap::create(BP, $_SERVER);
            }
        } catch (Exception $e) {
            echo 'Exception: ' . $e->getMessage() . ' Trace: ' . $e->getTraceAsString();
        }

        if ($bootstrapMagento2) {
            $objectManager = $bootstrapMagento2->getObjectManager();
            $state = $objectManager->get('Magento\Framework\App\State');
            $state->setAreaCode(Area::AREA_ADMINHTML);

            /** @var ProductManagerMagento2\Magento2Router $router */
            $router = $objectManager->get(
                ProductManagerMagento2\Magento2Router::class
            );

            $router->execute($encryptionKey, $username, $password);

            exit();
        }
    }

    /**
     * @param RequestInterface $request
     *
     * @return bool|null
     */
    public function validateForCsrf(RequestInterface $request): ?bool
    {
        return true;
    }

    /**
     * @param RequestInterface $request
     *
     * @return InvalidRequestException|null
     */
    public function createCsrfValidationException(RequestInterface $request): ?InvalidRequestException
    {
        return null;
    }
}